## eckit 1.32.3

=== CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

########################################################################################################################


cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.7 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

project( eckit LANGUAGES CXX )

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

########################################################################################################################
### dependencies and options

ecbuild_add_option( FEATURE BUILD_TOOLS
                    DEFAULT ON
                    DESCRIPTION "Build the command line tools" )

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT OFF
                    DESCRIPTION "Experimental features that havent graduated to production ready code" )

ecbuild_add_option( FEATURE SANDBOX
                    DEFAULT OFF
                    DESCRIPTION "Sandbox playground for prototyping code that may never see the light of day" )

### thread library ( preferably pthreads ) --- Must be called before FindCUDA!

if( ${CMAKE_VERSION} VERSION_LESS 3.14 )
    # Following variable is unused for CMake > 3.14
    set( CMAKE_THREAD_PREFER_PTHREAD 1 )
endif()

if( NOT DEFINED THREADS_PREFER_PTHREAD_FLAG )
  set( THREADS_PREFER_PTHREAD_FLAG 1 )
endif()

### Set THREADS_HAVE_PTHREAD_ARG variable to false so that it can be recomputed based on
### THREADS_PREFER_PTHREAD_FLAG, in case other project had it on a different setting.
### This is certainly a CMake bug ( see ECKIT-426 )
set( THREADS_HAVE_PTHREAD_ARG FALSE )
find_package( Threads REQUIRED )
set( THREADS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT} )

ecbuild_add_option( FEATURE ECKIT_MEMORY_FACTORY_BUILDERS_DEBUG
                    DEFAULT OFF
                    DESCRIPTION "eckit::Factory builders debug"
                    ADVANCED )

ecbuild_add_option( FEATURE ECKIT_MEMORY_FACTORY_EMPTY_DESTRUCTION
                    DEFAULT OFF
                    DESCRIPTION "eckit::Factory empty destruction (system dependant)"
                    ADVANCED )

### eckit::mpi

ecbuild_add_option( FEATURE MPI
                    DEFAULT ON
                    DESCRIPTION "Use system MPI libraries"
                    REQUIRED_PACKAGES "MPI COMPONENTS C" )

### eckit::cmd

ecbuild_find_lexyacc()

ecbuild_add_option( FEATURE ECKIT_CMD
                    DEFAULT ON
                    DESCRIPTION "Utilities for administration tools"
                    CONDITION LEXYACC_FOUND
                    REQUIRED_PACKAGES "Curses" )

### eckit::sql

ecbuild_add_option( FEATURE ECKIT_SQL
                    DEFAULT ON
                    DESCRIPTION "An SQL engine"
                    CONDITION LEXYACC_FOUND )

### Eigen

ecbuild_add_option( FEATURE EIGEN
                    DESCRIPTION "Eigen linear algebra library"
                    REQUIRED_PACKAGES Eigen3 )

set_package_properties( Eigen3 PROPERTIES
                        DESCRIPTION "C++ template library for linear algebra"
                      )

### OpenMP

ecbuild_add_option( FEATURE OMP
                    DEFAULT OFF
                    DESCRIPTION "OpenMP linear algebra backend"
                    REQUIRED_PACKAGES "OpenMP COMPONENTS CXX" )

if( NOT TARGET OpenMP::OpenMP_CXX )
    set( eckit_HAVE_OMP 0 )
endif()

### RADOS

ecbuild_add_option( FEATURE RADOS
                    DEFAULT OFF
                    DESCRIPTION "Ceph/Rados storage support"
                    REQUIRED_PACKAGES Rados )

### Armadillo

ecbuild_add_option( FEATURE ARMADILLO
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "Armadillo linear algebra library"
                    REQUIRED_PACKAGES Armadillo )

set_package_properties( Armadillo PROPERTIES
                        DESCRIPTION "C++ linear algebra"
                      )

### MKL

ecbuild_add_option( FEATURE MKL
                    DESCRIPTION "MKL linear algebra library"
                    REQUIRED_PACKAGES MKL )

### Compression options

ecbuild_add_option( FEATURE BZIP2
                    DESCRIPTION "BZip2 support for compression"
                    REQUIRED_PACKAGES BZip2 )

ecbuild_add_option( FEATURE SNAPPY
                    DESCRIPTION "Snappy support for compression"
                    REQUIRED_PACKAGES Snappy )

ecbuild_add_option( FEATURE LZ4
                    DESCRIPTION "LZ4 support for compression"
                    REQUIRED_PACKAGES LZ4 )

ecbuild_add_option( FEATURE AEC
                    DESCRIPTION "AEC support for compression"
                    REQUIRED_PACKAGES AEC )

ecbuild_add_option( FEATURE ZIP
                    DESCRIPTION "ZIP support for compression"
                    REQUIRED_PACKAGES libzip )

### Hashing options

ecbuild_add_option( FEATURE XXHASH
                    DESCRIPTION "xxHash support for hashing" )

### eckit::codec

ecbuild_add_option( FEATURE ECKIT_CODEC
                    DEFAULT ON
                    DESCRIPTION "eckit::codec encoding/decoding library" )

set( eckit_CODEC_STATIC_ASSERT ON CACHE BOOL "eckit::codec static assertions" )

### eckit::maths

ecbuild_add_option( FEATURE CONVEX_HULL
                    DEFAULT OFF
                    DESCRIPTION "eckit::maths library convex hull/Delaunay triangulation" )
                    # REQUIRED_PACKAGES "Qhull COMPONENTS C CXX"

if( eckit_HAVE_CONVEX_HULL )
    find_package( Qhull REQUIRED CONFIG )

    if( NOT TARGET Qhull::qhullcpp OR NOT TARGET Qhull::qhullstatic_r )
        message( FATAL_ERROR "eckit::maths ENABLE_CONVEX_HULL requires Qhull C/C++ libraries" )
    endif()

    add_library(Qhull::Qhull INTERFACE IMPORTED)
    target_link_libraries(Qhull::Qhull INTERFACE Qhull::qhullcpp Qhull::qhullstatic_r )
endif()

### eckit::geo

ecbuild_add_option( FEATURE ECKIT_GEO
                    DEFAULT ON
                    DESCRIPTION "eckit::geo geometry library" )

ecbuild_add_option( FEATURE GEO_GRID_FESOM
                    DEFAULT ON
                    CONDITION eckit_HAVE_ECKIT_GEO AND eckit_HAVE_ECKIT_CODEC AND eckit_HAVE_LZ4
                    DESCRIPTION "eckit::geo geometry library support for FESOM grids" )

ecbuild_add_option( FEATURE GEO_GRID_ICON
                    DEFAULT ON
                    CONDITION eckit_HAVE_ECKIT_GEO AND eckit_HAVE_ECKIT_CODEC AND eckit_HAVE_LZ4
                    DESCRIPTION "eckit::geo geometry library support for ICON grids" )

ecbuild_add_option( FEATURE GEO_GRID_ORCA
                    DEFAULT ON
                    CONDITION eckit_HAVE_ECKIT_GEO AND eckit_HAVE_ECKIT_CODEC AND eckit_HAVE_LZ4
                    DESCRIPTION "eckit::geo geometry library support for ORCA grids" )

ecbuild_add_option( FEATURE GEO_CACHING
                    DEFAULT OFF
                    CONDITION eckit_HAVE_ECKIT_GEO
                    DESCRIPTION "eckit::geo geometry library default caching behaviour" )

ecbuild_add_option( FEATURE GEO_BITREPRODUCIBLE
                    DEFAULT OFF
                    CONDITION eckit_HAVE_ECKIT_GEO
                    DESCRIPTION "eckit::geo geometry library bit reproducibility tests" )

ecbuild_add_option( FEATURE GEO_PROJECTION_PROJ_DEFAULT
                    DEFAULT OFF
                    CONDITION eckit_HAVE_ECKIT_GEO
                    DESCRIPTION "eckit::geo geometry library default to PROJ-based projections" )

ecbuild_add_option( FEATURE GEO_AREA_SHAPEFILE
                    DEFAULT ON
                    CONDITION eckit_HAVE_ECKIT_GEO AND eckit_HAVE_ZIP
                    REQUIRED_PACKAGES shapelib
                    DESCRIPTION "eckit::geo geometry library support for shapefiles" )

if( eckit_HAVE_GEO_AREA_SHAPEFILE )
    if( NOT TARGET shapelib::shp OR NOT TARGET libzip::zip )
        message( FATAL_ERROR "eckit::geo geometry library support for shapefiles requires the shapelib::shp and libzip::zip libraries" )
    endif()
endif()

set( eckit_GEO_CACHE_PATH "~/.local/share/eckit/geo" )

### LAPACK

if( eckit_HAVE_MKL )
    set( eckit_HAVE_LAPACK 1 )
    set( LAPACK_LIBRARIES ${MKL_LIBRARIES} )
else()
    ecbuild_add_option( FEATURE LAPACK
                        DESCRIPTION "Linear Algebra PACKage"
                        REQUIRED_PACKAGES "LAPACK QUIET" )
endif()

### OpenSSL (for SHA1 and MD4)

ecbuild_add_option( FEATURE SSL
                    DEFAULT OFF # We only use deprecated functionality from OpenSSL
                    DESCRIPTION "OpenSSL support"
                    REQUIRED_PACKAGES OpenSSL )

if( OPENSSL_FOUND )
  ecbuild_info("OpenSSL version ${OPENSSL_VERSION} -- libs [${OPENSSL_LIBRARIES}] incs [${OPENSSL_INCLUDE_DIR}]")
endif()

#### Curl

ecbuild_add_option( FEATURE CURL
                    DESCRIPTION "Curl library for transfering data with URLs"
                    REQUIRED_PACKAGES "CURL 7.20" )

if(HAVE_CURL)
  ecbuild_info("Curl version ${CURL_VERSION_STRING} -- libs [${CURL_LIBRARIES}] incs [${CURL_INCLUDE_DIRS}]")
endif()

#### Jemalloc

ecbuild_add_option( FEATURE JEMALLOC
                    DEFAULT OFF
                    DESCRIPTION "Link against jemalloc memory allocator"
                    REQUIRED_PACKAGES Jemalloc )

#### CUDA

ecbuild_add_option( FEATURE CUDA
                    DEFAULT OFF
                    DESCRIPTION "CUDA GPU linear algebra operations"
                    REQUIRED_PACKAGES CUDAToolkit )

#### HIP

ecbuild_add_option( FEATURE HIP
                    DEFAULT OFF
                    DESCRIPTION "HIP GPU linear algebra operations"
                    REQUIRED_PACKAGES hip hipsparse )

### ViennaCL

ecbuild_add_option( FEATURE VIENNACL
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "ViennaCL OpenCL linear algebra operations"
                    REQUIRED_PACKAGES ViennaCL )

set_package_properties( ViennaCL PROPERTIES
                        DESCRIPTION "linear algebra library for computations on many-core architectures"
                        TYPE RECOMMENDED
                        PURPOSE "Dense and sparse matrix operations on OpenCL devices" )

### LibRsync

ecbuild_add_option( FEATURE RSYNC
                    DEFAULT OFF
                    DESCRIPTION "librsync implementation of the rsync algorithm"
                    REQUIRED_PACKAGES LibRsync )
if( HAVE_RSYNC )
  set( LIBRSYNC_LIBRARIES rsync )
endif()


### Performance tests

ecbuild_add_option( FEATURE EXTRA_TESTS
                    DEFAULT OFF
                    DESCRIPTION "Add additional unit/performance tests" )

### UNICODE support

check_include_file_cxx("codecvt" HAVE_CXX_CODECVT)

ecbuild_add_option( FEATURE UNICODE
                    DEFAULT ON
                    CONDITION HAVE_CXX_CODECVT
                    DESCRIPTION "Add support for Unicode characters in Yaml/JSON parsers" )

### async io support

find_package( AIO )
ecbuild_add_option( FEATURE AIO
                    DEFAULT ON
                    CONDITION ${AIO_FOUND}
                    DESCRIPTION "support for asynchronous IO")

### PROJ support

ecbuild_add_option( FEATURE PROJ
                    DEFAULT OFF
                    DESCRIPTION "support PROJ-based projections"
                    REQUIRED_PACKAGES "PROJ 9.1.1" )

### c math library, needed when including "math.h"

find_package( CMath )

### realtime library implements shm_open on Linux
if( CMAKE_SYSTEM_NAME MATCHES "Linux" )
    find_package( Realtime )
    if( REALTIME_FOUND ) # check that aio needs realtime
        set( RT_LIBRARIES ${RT_LIB} )
    endif()
else()
    set( RT_LIBRARIES "" )
endif()

### sanity checks

include(cmake/check_time_t_Y2038.cmake) # check Y2038 time_t compatibility

=== regressions/CMakeLists.txt ===
list( APPEND regressions ECKIT-175 ECKIT-221 ECKIT-166 )

foreach( r ${regressions} )

  configure_file( ${r}.sh.in ${r}.sh @ONLY )

  ecbuild_add_executable(
    NOINSTALL
    TARGET   ${r}.x
    SOURCES  ${r}.cc
    LIBS     eckit_mpi eckit )

  ecbuild_add_test(
    TYPE     SCRIPT
    COMMAND  ${r}.sh )

endforeach()

=== share/CMakeLists.txt ===
add_subdirectory(eckit)

=== tests/CMakeLists.txt ===
add_subdirectory( config )
add_subdirectory( container )
add_subdirectory( exception )
add_subdirectory( filesystem )
add_subdirectory( geometry )
add_subdirectory( io )
add_subdirectory( large_file )
add_subdirectory( linalg )
add_subdirectory( log )
add_subdirectory( maths )
add_subdirectory( memory )
add_subdirectory( mpi )
add_subdirectory( option )
add_subdirectory( parser )
add_subdirectory( runtime )
add_subdirectory( serialisation )
add_subdirectory( system )
add_subdirectory( testing )
add_subdirectory( thread )
add_subdirectory( types )
add_subdirectory( utils )
add_subdirectory( value )

if( eckit_HAVE_ECKIT_SQL )
    add_subdirectory( sql )
endif()

if( eckit_HAVE_ECKIT_CODEC )
    add_subdirectory( codec )
endif()

if( eckit_HAVE_ECKIT_GEO )
    add_subdirectory( geo )
endif()

if( eckit_HAVE_EXPERIMENTAL )
    add_subdirectory( experimental )
endif()

=== src/sandbox/CMakeLists.txt ===
ecbuild_add_executable( TARGET sandbox_pool NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES pool.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_net NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES net.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_pipe NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES pipe.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_tcp_client NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES tcp_client.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_tcp_server NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES tcp_server.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_tcp_server_threaded NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES tcp_server_threaded.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_tcp_server_forked NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES tcp_server_forked.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET sandbox_arg NOINSTALL
                        CONDITION HAVE_SANDBOX AND HAVE_ECKIT_CMD
                        SOURCES arg.cc
                        LIBS eckit_cmd )

ecbuild_add_executable( TARGET  sandbox_tcp_client_json NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES tcp_client_json.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_mpmc NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES mpmc.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_shint NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES shint.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_memsharedlimit NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES memsharedlimit.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET sandbox_mpiobjsend NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES mpiobjsend.cc
                        LIBS eckit_mpi eckit )

ecbuild_add_executable( TARGET sandbox_udp_server NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES udp_server.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET sandbox_udp_client NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES udp_client.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_multi_socket_server NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES multi_socket_server.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_multi_socket_client NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES multi_socket_client.cc
                        LIBS eckit )

ecbuild_add_executable( TARGET  sandbox_shmem_ipc NOINSTALL
                        CONDITION HAVE_SANDBOX
                        SOURCES shmem_ipc.cc
                        LIBS eckit )

=== tests/geometry/CMakeLists.txt ===
foreach( _test coordinate_helpers great_circle kdtree sphere kpoint points polygon )
    ecbuild_add_test( TARGET  eckit_test_geometry_${_test}
                      SOURCES test_${_test}.cc
                      LIBS    eckit_geometry )
endforeach()

=== tests/linalg/CMakeLists.txt ===
# (C) Copyright 1996- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

ecbuild_add_test( TARGET    eckit_test_linalg_factory
                  ARGS      --log_level=message
                  SOURCES   test_la_factory.cc
                  LIBS      eckit_linalg )

ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend
                  ARGS      --log_level=message
                  SOURCES   test_la_linalg_dense.cc util.h
                  LIBS      eckit_linalg )

ecbuild_add_test( TARGET    eckit_test_linalg_sparse_backend
                  ARGS      --log_level=message
                  SOURCES   test_la_linalg_sparse.cc util.h
                  LIBS      eckit_linalg )

ecbuild_add_test( TARGET    eckit_test_linalg_matrix
                  ARGS      --log_level=message
                  SOURCES   test_la_matrix.cc
                  LIBS      eckit_linalg )

ecbuild_add_test( TARGET    eckit_test_linalg_tensor
                  ARGS      --log_level=message
                  SOURCES   test_la_tensor.cc util.h
                  LIBS      eckit_linalg )

# LinearAlgebra
ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend
                  ARGS      --log_level=message
                  SOURCES   test_la_linalg.cc util.h
                  LIBS      eckit_linalg )

ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend_generic
                  COMMAND   eckit_test_linalg_mixed_backend
                  ARGS      --log_level=message -linearAlgebraBackend generic )

ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend_armadillo
                  COMMAND   eckit_test_linalg_mixed_backend
                  CONDITION eckit_HAVE_ARMADILLO
                  ARGS      --log_level=message -linearAlgebraBackend armadillo )

# This test seems to have a system call exit with 1 even though tests pass.
# Ignore system errors, see also http://stackoverflow.com/a/20360334/396967
ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend_cuda
                  COMMAND   eckit_test_linalg_mixed_backend
                  CONDITION eckit_HAVE_CUDA
                  ARGS      --log_level=message -linearAlgebraBackend cuda --catch_system_errors=no )

ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend_eigen
                  COMMAND   eckit_test_linalg_mixed_backend
                  CONDITION eckit_HAVE_EIGEN
                  ARGS      --log_level=message -linearAlgebraBackend eigen )

ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend_lapack
                  COMMAND   eckit_test_linalg_mixed_backend
                  CONDITION eckit_HAVE_LAPACK
                  ARGS      --log_level=message -linearAlgebraBackend lapack )

ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend_mkl
                  COMMAND   eckit_test_linalg_mixed_backend
                  CONDITION eckit_HAVE_MKL
                  ARGS      --log_level=message -linearAlgebraBackend mkl )

ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend_viennacl
                  COMMAND   eckit_test_linalg_mixed_backend
                  CONDITION eckit_HAVE_VIENNACL
                  ARGS      --log_level=message -linearAlgebraBackend viennacl )

ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend_openmp
                  COMMAND   eckit_test_linalg_mixed_backend
                  CONDITION eckit_HAVE_OMP
                  ARGS      --log_level=message -linearAlgebraBackend openmp )

# LinearAlgebraDense

ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend_generic
                  COMMAND   eckit_test_linalg_dense_backend
                  ARGS      --log_level=message -linearAlgebraDenseBackend generic )

ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend_armadillo
                  COMMAND   eckit_test_linalg_dense_backend
                  CONDITION eckit_HAVE_ARMADILLO
                  ARGS      --log_level=message -linearAlgebraDenseBackend armadillo )

# This test seems to have a system call exit with 1 even though tests pass.
# Ignore system errors, see also http://stackoverflow.com/a/20360334/396967
ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend_cuda
                  COMMAND   eckit_test_linalg_dense_backend
                  CONDITION eckit_HAVE_CUDA
                  ARGS      --log_level=message -linearAlgebraDenseBackend cuda --catch_system_errors=no )

ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend_eigen
                  COMMAND   eckit_test_linalg_dense_backend
                  CONDITION eckit_HAVE_EIGEN
                  ARGS      --log_level=message -linearAlgebraDenseBackend eigen )

ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend_lapack
                  COMMAND   eckit_test_linalg_dense_backend
                  CONDITION eckit_HAVE_LAPACK
                  ARGS      --log_level=message -linearAlgebraDenseBackend lapack )

ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend_mkl
                  COMMAND   eckit_test_linalg_dense_backend
                  CONDITION eckit_HAVE_MKL
                  ARGS      --log_level=message -linearAlgebraDenseBackend mkl )

ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend_viennacl
                  COMMAND   eckit_test_linalg_dense_backend
                  CONDITION eckit_HAVE_VIENNACL
                  ARGS      --log_level=message -linearAlgebraDenseBackend viennacl )

ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend_openmp
                  COMMAND   eckit_test_linalg_dense_backend
                  CONDITION eckit_HAVE_OMP
                  ARGS      --log_level=message -linearAlgebraDenseBackend openmp )

# LinearAlgebraSparse

ecbuild_add_test( TARGET    eckit_test_linalg_sparse_backend_generic
                  COMMAND   eckit_test_linalg_sparse_backend
                  ARGS      --log_level=message -linearAlgebraSparseBackend generic )

# This test seems to have a system call exit with 1 even though tests pass.
# Ignore system errors, see also http://stackoverflow.com/a/20360334/396967
ecbuild_add_test( TARGET    eckit_test_linalg_sparse_backend_cuda
                  COMMAND   eckit_test_linalg_sparse_backend
                  CONDITION eckit_HAVE_CUDA
                  ARGS      --log_level=message -linearAlgebraSparseBackend cuda --catch_system_errors=no )

ecbuild_add_test( TARGET    eckit_test_linalg_sparse_backend_hip
                  COMMAND   eckit_test_linalg_sparse_backend
                  CONDITION eckit_HAVE_HIP
                  ARGS      --log_level=message -linearAlgebraSparseBackend hip )

ecbuild_add_test( TARGET    eckit_test_linalg_sparse_backend_eigen
                  COMMAND   eckit_test_linalg_sparse_backend
                  CONDITION eckit_HAVE_EIGEN
                  ARGS      --log_level=message -linearAlgebraSparseBackend eigen )

ecbuild_add_test( TARGET    eckit_test_linalg_sparse_backend_mkl
                  COMMAND   eckit_test_linalg_sparse_backend
                  CONDITION eckit_HAVE_MKL
                  ARGS      --log_level=message -linearAlgebraSparseBackend mkl )

ecbuild_add_test( TARGET    eckit_test_linalg_sparse_backend_viennacl
                  COMMAND   eckit_test_linalg_sparse_backend
                  CONDITION eckit_HAVE_VIENNACL
                  ARGS      --log_level=message -linearAlgebraSparseBackend viennacl )

ecbuild_add_test( TARGET    eckit_test_linalg_sparse_backend_openmp
                  COMMAND   eckit_test_linalg_sparse_backend
                  CONDITION eckit_HAVE_OMP
                  ARGS      --log_level=message -linearAlgebraSparseBackend openmp )

#

ecbuild_add_test( TARGET    eckit_test_linalg_sparse
                  ARGS      --log_level=message
                  SOURCES   test_la_sparse.cc util.h
                  LIBS      eckit_linalg )

ecbuild_add_test( TARGET    eckit_test_linalg_streaming
                  ARGS      --log_level=message
                  SOURCES   test_la_streaming.cc util.h
                  LIBS      eckit_linalg )

=== tests/parser/CMakeLists.txt ===
ecbuild_add_test( TARGET   eckit_test_parser_json
                  SOURCES  test_json.cc
                  LIBS     eckit )

list( APPEND yaml
2.1.yaml 2.10.yaml 2.11.yaml 2.12.yaml 2.13.yaml 2.14.yaml 2.15.yaml 2.16.yaml 2.17.yaml
2.18.yaml 2.19.yaml 2.2.yaml 2.20.yaml 2.21.yaml 2.22.yaml 2.23.yaml 2.24.yaml 2.25.yaml
2.26.yaml 2.27.yaml 2.28.yaml 2.3.yaml 2.4.yaml 2.5.yaml 2.6.yaml 2.7.yaml 2.8.yaml 2.9.yaml
cfg.1.yaml string.yaml unicode.yaml
)

foreach( r ${yaml} )
   configure_file( ${r} ${CMAKE_CURRENT_BINARY_DIR}/${r} @ONLY )
endforeach()


ecbuild_add_test( TARGET   eckit_test_parser_yaml
                  SOURCES  test_yaml.cc
                  LIBS     eckit )

ecbuild_add_test( TARGET   eckit_test_parser_stream_parser
                  SOURCES  test_stream_parser.cc
                  LIBS     eckit )

ecbuild_add_test( TARGET   eckit_test_parser_csv
                  SOURCES  test_csv.cc
                  LIBS     eckit )

=== tests/system/CMakeLists.txt ===
# file accessed in the test

file( WRITE "${CMAKE_BINARY_DIR}/etc/eckit/test/test.cfg" "Just for testing" )

ecbuild_add_test(   TARGET      eckit_test_system_library
                    SOURCES     test_system_library.cc
					LIBS        eckit )

=== tests/thread/CMakeLists.txt ===

if( NOT ENABLE_WARNINGS )
  list( APPEND suppress_warnings
    $<$<CXX_COMPILER_ID:Cray>:-h nomessage=3140> # Disable optimisation warning in debug build due to use of intrinsics
  )
  set_source_files_properties( test_mutex.cc PROPERTIES COMPILE_OPTIONS "${suppress_warnings}" )
endif()

ecbuild_add_test( TARGET      eckit_test_thread_mutex
                  SOURCES     test_mutex.cc
                  LIBS        eckit )

=== tests/utils/CMakeLists.txt ===
### test data files
list( APPEND test_data_files
2t_sfc.grib
2t_sfc_regrid.grib
vo-d_6ml.grib
u-v_6ml.grib
q_6ml_regrid.grib
)

if(HAVE_EXTRA_TESTS)
        ecbuild_get_test_multidata( TARGET get_eckit_test_data
                                    NAMES ${test_data_files}
                                    NOCHECK )
endif()

ecbuild_add_test( TARGET      eckit_test_utils_byteswap
                  SOURCES     test_byteswap.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_string_tools
                  SOURCES     test_string_tools.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_translator
                  SOURCES     test_translator.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_tokenizer
                  SOURCES     test_tokenizer.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_semanticversion
                  SOURCES     test_semanticversion.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_rendezvoushash
                  SOURCES     test_rendezvoushash.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_rle
                  SOURCES     test_rle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_compressor
                  SOURCES     test_compressor.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_optional
                  SOURCES     test_optional.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_hashing
                  CONDITION   eckit_HAVE_SSL
                  INCLUDES    "${OPENSSL_INCLUDE_DIR}"
                  SOURCES     test_hashing.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_hash_performance
                  CONDITION   HAVE_EXTRA_TESTS
                  SOURCES     hash-performance.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_compression_performance
                  CONDITION   HAVE_EXTRA_TESTS
                  TEST_DEPENDS get_eckit_test_data
                  SOURCES     compression-performance.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_rsync
                  CONDITION   HAVE_RSYNC
                  SOURCES     test_rsync.cc
                  LIBS        eckit rsync )

ecbuild_add_test( TARGET      eckit_test_regex
                  SOURCES     test_regex.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_literals
                  SOURCES     test_literals.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_safe_casts
                  SOURCES     test_safe_casts.cc
                  LIBS        eckit )

=== src/eckit/codec/CMakeLists.txt ===

configure_file( eckit_codec_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/eckit_codec_config.h @ONLY )
install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/eckit_codec_config.h
    DESTINATION ${INSTALL_INCLUDE_DIR}/eckit/codec
)

ecbuild_add_library(
    TARGET eckit_codec

    INSTALL_HEADERS    ALL
    HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}/eckit/codec
    PUBLIC_LIBS        eckit
    PUBLIC_INCLUDES
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
      $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>

    SOURCES
        ${CMAKE_CURRENT_BINARY_DIR}/eckit_codec_config.h
        Data.cc
        Data.h
        Exceptions.cc
        Exceptions.h
        FileStream.cc
        FileStream.h
        Metadata.cc
        Metadata.h
        ReadRequest.cc
        ReadRequest.h
        Record.cc
        Record.h
        RecordItem.cc
        RecordItem.h
        RecordItemReader.cc
        RecordItemReader.h
        RecordPrinter.cc
        RecordPrinter.h
        RecordReader.cc
        RecordReader.h
        RecordWriter.cc
        RecordWriter.h
        Session.cc
        Session.h
        Stream.cc
        Stream.h
        codec.h
        detail/Base64.cc
        detail/Base64.h
        detail/Checksum.cc
        detail/Checksum.h
        detail/DataInfo.h
        detail/DataType.cc
        detail/DataType.h
        detail/Decoder.cc
        detail/Decoder.h
        detail/Defaults.h
        detail/demangle.cc
        detail/demangle.h
        detail/Encoder.cc
        detail/Encoder.h
        detail/Endian.h
        detail/Link.cc
        detail/Link.h
        detail/NoConfig.h
        detail/ParsedRecord.h
        detail/RecordInfo.h
        detail/RecordSections.h
        detail/Reference.h
        detail/StaticAssert.h
        detail/Time.cc
        detail/Time.h
        detail/Type.h
        detail/TypeTraits.h
        detail/Version.h
        detail/sfinae.h
        detail/tag.h
        print/Bytes.cc
        print/Bytes.h
        print/JSONFormat.cc
        print/JSONFormat.h
        print/TableFormat.cc
        print/TableFormat.h
        types/array.h
        types/array/ArrayMetadata.cc
        types/array/ArrayMetadata.h
        types/array/ArrayReference.cc
        types/array/ArrayReference.h
        types/array/adaptors/StdArrayAdaptor.h
        types/array/adaptors/StdVectorAdaptor.h
        types/array/adaptors/StdVectorOfStdArrayAdaptor.h
        types/scalar.cc
        types/scalar.h
        types/string.h
)

target_compile_features( eckit_codec PUBLIC cxx_std_17 )

=== debian/changelog ===
eckit (1.32.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 03 Nov 2025 07:17:16 +0000

=== debian/tests/control ===
# Simple check on libs and dependencies being present

Test-Command: set -e
  ; eckit-version --help 2> /dev/null
Depends: libeckit-utils
Restrictions: superficial

## eckit 1.32.4

=== debian/changelog ===
eckit (1.32.4-3) unstable; urgency=medium

  * Standards-Version: 4.7.3
  * Clean autogenerated setup.py. Closes: #1045001, #1049734
  * Drop Priority: optional from source in d/control per new policy
  * Don't use RADOS on loong64; not supported  there yet

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 05 Jan 2026 08:40:36 +0000

eckit (1.32.4-2) unstable; urgency=medium

  * Build against fixed ecbuild. Closes: #1122052
  * Move d/copyright to DEP-5, licensrecon fixes
  * Close previously fixed bug. Closes: #1044845

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 07 Dec 2025 12:55:06 +0000

eckit (1.32.4-1) unstable; urgency=medium

  * New upstream release
  * d/gbp.conf: now use pristine-tar
  * d/watch: Move to version 4 format

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 05 Dec 2025 15:54:54 +0000

=== debian/control ===
Source: eckit
Section: science
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  ecbuild (>= 3.6.1-1~),
  chrpath,
  flex,
  bison,
  libopenblas-dev [ !alpha !hurd-amd64 ],
  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 ],
  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
  libaec-dev,
  libxxhash-dev,
  libjemalloc-dev,
  librados-dev [ !loong64 ],
  libradospp-dev,
  libproj-dev, 
  libbz2-dev,
  liblz4-dev,
  libshp-dev,
  libzip-dev,
  libeigen3-dev,
  libsnappy-dev,
  librsync-dev,
  libqhull-dev,
  mpi-default-dev,
  doxygen,
  python3-all,
  libssl-dev,
  libcurl4-gnutls-dev (>=  7.20),
  libncurses-dev
Standards-Version: 4.7.3
Homepage: https://github.com/ecmwf/eckit
Vcs-Git: https://salsa.debian.org/science-team/eckit.git -b debian/latest

Package: libeckit-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libeckit0d (= ${binary:Version}), libeckit-utils (= ${binary:Version}),
  mpi-default-dev,
  libaec-dev,
  libssl-dev,
  libcurl4-gnutls-dev,
  libxxhash-dev,
  libjemalloc-dev,
  libsnappy-dev,
  liblz4-dev,
  libbz2-dev,
  libeigen3-dev,
  libopenblas-dev [ amd64 arm64 mips64el ppc64el s390x ppc64],
  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
  ${shlibs:Depends}, ${misc:Depends}
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit-utils
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, libeckit0d ( = ${binary:Version}),  ${shlibs:Depends}
Recommends: libeckit-dev
Description: C++ toolkit for ECMWF tools and applications - development files
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f


# TODO:
#   - Flang version doesn't build. 

export DH_VERBOSE=1

DO_TEST:=true

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

TMPDIR:=$(CURDIR)/debian/tmp
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

NO_RADOS_ARCH:= loong64
RADOS:= $(if $(filter $(DEB_TARGET_ARCH), $(NO_RADOS_ARCH)),Off,On)


# JEMALLOC Turned off as it breaks magics-python currently (TLS space)

BUILD_FLAGS = \ -DCMAKE_MODULE_PATH=/usr/share/ecbuild/cmake \
	-DHAVE_TESTS=Off \
	-DENABLE_RSYNC=On \
	-DENABLE_CONVEX_HULL=On \
	-DENABLE_SSL=On \
	-DENABLE_ECKIT_GEO=On \
	-DENABLE_PROJ=On \
	-DENABLE_RADOS=$(RADOS) \
	-DENABLE_OMP=On \
	-DENABLE_JEMALLOC=Off

%:
	dh $@ --buildsystem=cmake

execute_after_dh_auto_clean:
	rm -rf debian/build-*

override_dh_auto_configure:
	dh_auto_configure --  ${BUILD_FLAGS} 
	( tar axpf $(CURDIR)/../eckit_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )

override_dh_auto_test:
	$(DO_TEST) && ( LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test  ) || true

override_dh_auto_install:
	dh_auto_install
	chrpath -d debian/tmp/usr/lib/*/*.so.0d
	# Fixup cmake files. Hack. can we do better with patches to upstream ?
	sed -i -e 's%/usr/bin/python %/usr/bin/python3 %g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-import.cmake
	sed -i -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-config.cmake
	sed -i -e 's%$${PACKAGE_PREFIX_DIR}/lib/cmake%${LIBDIR}/cmake%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-config.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%g'  $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets-none.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/lib/libeckit%${LIBDIR}/libeckit%g'  $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets-none.cmake
	sed -i -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g'  $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	sed -i -e 's%PROJ::proj;%%g'  $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/lib/libeckit%${LIBDIR}/libeckit%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/module%${MODULEDIR}%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	chmod -x $(TMPDIR)/$(LIBDIR)/cmake/eckit/*

## eckit 1.33.0

=== share/eckit/geo/CMakeLists.txt ===
set(_files)

list(APPEND _files "area.yaml" "grid.yaml")

if(eckit_HAVE_GEO_AREA_SHAPEFILE)
    list(APPEND _files "shapefile.yaml")
endif()

if(ECKIT_GEO_CODEC_GRIDS)
    list(APPEND _files "FESOM.yaml" "ICON-CH.yaml" "ICON-DWD.yaml" "ICON-MPIM.yaml" "ORCA.yaml")
endif()

set(_destination "share/eckit/geo")

install(FILES ${_files} DESTINATION ${_destination} PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

foreach(_file ${_files})
    configure_file(${_file} "${CMAKE_BINARY_DIR}/${_destination}/${_file}" COPYONLY)
endforeach()

=== debian/changelog ===
eckit (1.33.0-1) unstable; urgency=medium

  * New upstream release
  * New shared lib libeckit_spec.so.0d
  * Add d/salsa-ci.yml

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 03 Feb 2026 06:58:49 +0000
